module RRRSpec
  module Cucumber2
    class CucumberRunnerFactory
      attr_reader :next_factory

      def initialize(next_factory)
        @next_factory = next_factory
      end

      def create(file_extension)
        unless Thread.current[:cucumber2_runner]
          Thread.current[:cucumber2_runner] = CucumberRunner.new
        end

        return Thread.current[:cucumber2_runner] if file_extension == '.feature'
        return Thread.current[:cucumber2_runner] if @next_factory == nil

        @next_factory.create file_extension
      end
    end
  end
end
